require 'datatables_server_side/version'
require 'active_support'
require 'active_support/core_ext/string/output_safety.rb' #raw() and h() methods
require 'active_support/core_ext/module/delegation.rb'# delegate method
require 'action_view'
module DatatablesServerSide
  class Datatables
    delegate :params, :link_to, :content_tag, :can?, :current_user, :t, to: :@view
    # delegate :h, to: ERB::Util
    include ActionView::Helpers::OutputSafetyHelper # this is to use raw()
    # include ApplicationHelper

    def initialize(view)
      @view = view
    end

    def as_json(options = {})
      raise NotImplementedError
    end

    protected

    def data
      raise NotImplementedError
    end

    def safe_attributes(data)
      data.map! do |array_value|
        if array_value.class==Array
          safe_attributes(array_value)
        elsif array_value.class!=NilClass
          array_value.to_s.html_safe
        end
      end
    end

    def records
      @records ||= fetch_records
    end

    def fetch_records
      raise NotImplementedError
    end

    def page
      params[:iDisplayStart].present? ? params[:iDisplayStart].to_i/per_page + 1 : 1
    end

    def per_page
      (params[:sSortDir_0].present? && params[:iDisplayLength].to_i > 0) ? params[:iDisplayLength].to_i : 10
    end

    def sort_column
      raise NotImplementedError
    end

    def sort_direction
      (params[:sSortDir_0].present? && params[:sSortDir_0] == 'desc') ? 'desc' : 'asc'
    end
  end
end
